.NOLIST
IFNDEF TONES_INC
TONES_INC EQU

Beep PROTO STDCALL, :DWORD, :DWORD
Sleep PROTO STDCALL, :DWORD

 T_00 EQU 0
T_000 EQU T_00

 T_C3 EQU 131
T_Cn3 EQU T_C3
T_Cs3 EQU 139
T_Db3 EQU T_Cs3
 T_D3 EQU 147
T_Dn3 EQU T_D3
T_Ds3 EQU 156
T_Eb3 EQU T_Ds3
 T_E3 EQU 165
T_En3 EQU T_E3
 T_F3 EQU 175
T_Fn3 EQU T_F3
T_Fs3 EQU 185
T_Gb3 EQU T_Fs3
 T_G3 EQU 196
T_Gn3 EQU T_G3
T_Gs3 EQU 208
T_Ab3 EQU T_Gs3
 T_A3 EQU 220
T_An3 EQU T_A3
T_As3 EQU 233
T_Bb3 EQU T_As3
 T_B3 EQU 247
T_Bn3 EQU T_B3

 T_C4 EQU 262
T_Cn4 EQU T_C4
T_Cs4 EQU 277
T_Db4 EQU T_Cs4
 T_D4 EQU 294
T_Dn4 EQU T_D4
T_Ds4 EQU 311
T_Eb4 EQU T_Ds4
 T_E4 EQU 330
T_En4 EQU T_E4
 T_F4 EQU 349
T_Fn4 EQU T_F4
T_Fs4 EQU 370
T_Gb4 EQU T_Fs4
 T_G4 EQU 392
T_Gn4 EQU T_G4
T_Gs4 EQU 415
T_Ab4 EQU T_Gs4
 T_A4 EQU 440
T_An4 EQU T_A4
T_As4 EQU 466
T_Bb4 EQU T_As4
 T_B4 EQU 494
T_Bn4 EQU T_B4

 T_C5 EQU 523
T_Cn5 EQU T_C5
T_Cs5 EQU 554
T_Db5 EQU T_Cs5
 T_D5 EQU 587
T_Dn5 EQU T_D5
T_Ds5 EQU 622
T_Eb5 EQU T_Ds5
 T_E5 EQU 659
T_En5 EQU T_E5
 T_F5 EQU 698
T_Fn5 EQU T_F5
T_Fs5 EQU 740
T_Gb5 EQU T_Fs5
 T_G5 EQU 784
T_Gn5 EQU T_G5
T_Gs5 EQU 831
T_Ab5 EQU T_Gs5
 T_A5 EQU 880
T_An5 EQU T_A5
T_As5 EQU 932
T_Bb5 EQU T_As5
 T_B5 EQU 988
T_Bn5 EQU T_B5

 T_C6 EQU 1047
T_Cn6 EQU T_C6
T_Cs6 EQU 1109
T_Db6 EQU T_Cs6
 T_D6 EQU 1175
T_Dn6 EQU T_D6
T_Ds6 EQU 1245
T_Eb6 EQU T_Ds6
 T_E6 EQU 1319
T_En6 EQU T_E6
 T_F6 EQU 1397
T_Fn6 EQU T_F6
T_Fs6 EQU 1480
T_Gb6 EQU T_Fs6
 T_G6 EQU 1568
T_Gn6 EQU T_G6
T_Gs6 EQU 1661
T_Ab6 EQU T_Gs6
 T_A6 EQU 1760
T_An6 EQU T_A6
T_As6 EQU 1865
T_Bb6 EQU T_As6
 T_B6 EQU 1976
T_Bn6 EQU T_B6

 T_C7 EQU 2093
T_Cn7 EQU T_C7
T_Cs7 EQU 2217
T_Db7 EQU T_Cs7
 T_D7 EQU 2349
T_Dn7 EQU T_D7
T_Ds7 EQU 2489
T_Eb7 EQU T_Ds7
 T_E7 EQU 2637
T_En7 EQU T_E7
 T_F7 EQU 2794
T_Fn7 EQU T_F7
T_Fs7 EQU 2960
T_Gb7 EQU T_Fs7
 T_G7 EQU 3136
T_Gn7 EQU T_G7
T_Gs7 EQU 3322
T_Ab7 EQU T_Gs7
 T_A7 EQU 3520
T_An7 EQU T_A7
T_As7 EQU 3729
T_Bb7 EQU T_As7
 T_B7 EQU 3951
T_Bn7 EQU T_B7

DIVR MACRO \
    num:REQ,
    denom:REQ
    IF ((num) MOD (denom)) GE ((denom)/2)
        EXITM <((num)/(denom)+1)>
    ENDIF
    EXITM <((num)/(denom))>
ENDM

TEMPO MACRO \
    bpm:=<120>
    T_BPM = bpm
ENDM

METER MACRO \
    num:=<4>,
    den:=<4>
    IF (den NE 2) AND (den NE 4) AND (den NE 8)
        .ERR <invalid macro operand (den)>
    ELSE
        IFNDEF T_BPM
            T_BPM = 120
        ENDIF
        IF den EQ 2
            T_N02 = DIVR(60000,T_BPM)
            T_N01 = T_N02 SHL 1
            T_N04 = T_N02 SHR 1
            T_N08 = T_N02 SHR 2
            T_N16 = T_N02 SHR 3
            T_Measure = num*T_N02
        ELSEIF den EQ 4
            T_N04 = DIVR(60000,T_BPM)
            T_N01 = T_N04 SHL 2
            T_N02 = T_N04 SHL 1
            T_N08 = T_N04 SHR 1
            T_N16 = T_N04 SHR 2
            T_Measure = num*T_N04
        ELSE
            T_N08 = DIVR(60000,T_BPM)
            T_N01 = T_N08 SHL 3
            T_N02 = T_N08 SHL 2
            T_N04 = T_N08 SHL 1
            T_N16 = T_N08 SHR 1
            T_Measure = num*T_N08
        ENDIF
    ENDIF
ENDM

REST MACRO \
    nLength:REQ
    EXITM <T_00,nLength>
ENDM

N MACRO \
    nPitch:REQ,
    nLength:REQ
    IF nPitch
        EXITM <nPitch,nLength>
    ENDIF
    EXITM <T_00,nLength>
ENDM

S MACRO \
    nPitch:REQ,
    nLength:REQ
    IF nPitch
        EXITM <nPitch,DIVR((nLength)*7,8),T_00,DIVR(nLength,8)>
    ENDIF
    EXITM <T_00,nLength>
ENDM

PLAYNOTE MACRO \
    nPitch:REQ,
    nLength:REQ
    IF nPitch
        INVOKE Beep, nPitch, nLength
    ELSE
        INVOKE Sleep, nLength
    ENDIF
ENDM

PLAYMEASURE MACRO \
    notes:VARARG
    T_TempCounter = 0
    T_TempBeats = 0
    FOR note,<notes>
        IF T_TempCounter MOD 2
            PLAYNOTE T_TempPitch,note
            T_TempBeats = T_TempBeats+note
        ELSE
            T_TempPitch = note
        ENDIF
        T_TempCounter = T_TempCounter+1
    ENDM
    IF (T_TempBeats LT T_Measure-16) OR (T_TempBeats GT T_Measure+16)
        .ERR <measure worth of beats required>
    ENDIF
ENDM

PLAY MACRO \
    notes:VARARG
    T_TempCounter = 0
    FOR note,<notes>
        IF T_TempCounter MOD 2
            PLAYNOTE T_TempPitch,note
        ELSE
            T_TempPitch = note
        ENDIF
        T_TempCounter = T_TempCounter+1
    ENDM
ENDM

REPEAT_START MACRO \
    repeatlabel:REQ,
    repeatcount:=<1>
    T_s&repeatlabel = repeatcount+1
.DATA
R_&repeatlabel DWORD T_s&repeatlabel
.CODE
    &repeatlabel:
ENDM

REPEAT_END MACRO \
    repeatlabel:REQ,
    restorelabels:VARARG
    IFNB <restorelabels>
        FOR name,<&restorelabels>
            MOV R_&name,T_s&name
        ENDM
    ENDIF
    DEC R_&repeatlabel
    CMP R_&repeatlabel,0
    JA repeatlabel
    MOV R_&repeatlabel,1
ENDM

START MACRO
    T_Start:
ENDM

SEGNO MACRO
    T_DS:
ENDM

CODA MACRO
    T_CODA:
ENDM

DC_AL_CODA MACRO \
    restorelabels:VARARG
.DATA
R_DCC DWORD 2
.CODE
    IFNB <restorelabels>
        FOR name,<&restorelabels>
            MOV R_&name,T_s&name
        ENDM
    ENDIF
    DEC R_DCC
    CMP R_DCC,0
    JA T_Start
    MOV R_DCC,1
    JMP T_CODA
ENDM

DS_AL_CODA MACRO \
    restorelabels:VARARG
.DATA
R_DSC DWORD 2
.CODE
    IFNB <restorelabels>
        FOR name,<&restorelabels>
            MOV R_&name,T_s&name
        ENDM
    ENDIF
    DEC R_DSC
    CMP R_DSC,0
    JA T_DS
    MOV R_DSC,1
    JMP T_CODA
ENDM

DC_AL_FINE MACRO \
    restorelabels:VARARG
.DATA
R_DCF DWORD 2
.CODE
    IFNB <restorelabels>
        FOR name,<&restorelabels>
            MOV R_&name,T_s&name
        ENDM
    ENDIF
    DEC R_DCF
    CMP R_DCF,0
    JA T_Start
    MOV R_DCF,1
ENDM

DS_AL_FINE MACRO \
    restorelabels:VARARG
.DATA
R_DSF DWORD 2
.CODE
    IFNB <restorelabels>
        FOR name,<&restorelabels>
            MOV R_&name,T_s&name
        ENDM
    ENDIF
    DEC R_DSF
    CMP R_DSF,0
    JA T_DS
    MOV R_DSF,1
ENDM

ENDING MACRO \
    name:REQ,
    endings:REQ
    IF endings LT 2
        .ERR <must have at least 2 endings>
    ENDIF
    
    
ENDM

ENDIF
.LIST